﻿Public Class _Default
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        whdg.DataSource = GetDataSource()
    End Sub

    Private Function GetDataSource() As DataSet
        Dim ds As DataSet = New DataSet("Set")
        ds.Tables.Add(GetParentData())
        ds.Tables.Add(GetChildData())
        ds.Relations.Add(ds.Tables("ParentTable").Columns("ID"), ds.Tables("ChildTable").Columns("ParentID"))
        Return ds
    End Function

    Public Function GetParentData() As DataTable
        Dim dt As DataTable = New DataTable("ParentTable")
        dt.Columns.Add("ID", GetType(Integer))
        dt.Columns.Add("Category", GetType(String))
        dt.Columns.Add("Series", GetType(String))
        dt.Columns.Add("Value", GetType(Double))
        Dim Categories As String() = {"Category A", "Category B", "Category C", "Category D"}
        Dim rnd As Random = New Random()

        For i As Integer = 0 To 10 - 1
            Dim category As String = Categories(rnd.[Next](0, 4))
            Dim series As Integer = rnd.[Next](1, 4)
            dt.Rows.Add(New Object() {i, category, "Series " & series, rnd.[Next](1000, 3000)})
        Next

        Return dt
    End Function

    Public Function GetChildData() As DataTable
        Dim dt As DataTable = New DataTable("ChildTable")
        dt.Columns.Add("ID", GetType(Integer))
        dt.Columns.Add("ParentID", GetType(Integer))
        dt.Columns.Add("Subcategory", GetType(String))
        dt.Columns.Add("Series", GetType(String))
        dt.Columns.Add("Value", GetType(Double))
        Dim Categories As String() = {"Category 1", "Category 2", "Category 3", "Category 4"}
        Dim rnd As Random = New Random()

        For i As Integer = 0 To 70 - 1
            Dim category As String = Categories(rnd.[Next](0, 4))
            Dim series As Integer = rnd.[Next](1, 4)
            dt.Rows.Add(New Object() {i, rnd.[Next](0, 10), category, "Series " & series, rnd.[Next](0, 10)})
        Next

        Return dt
    End Function

End Class